if arg[#arg] == "debug" then 
	require("lldebugger").start()
end

-- https://sheepolution.com/learn/book/23

local bump = require 'bump'

local colliders = {}
local world 
local player
local text = ""

function love.load(args)
    world = bump.newWorld(32)

    --These callback function names can be almost any you want:
    --world:setCallbacks(beginContact, endContact, preSolve, postSolve)

    for x = 3, 20, 1 do
        local width = 32
        local height = 32
        local spacing = 0
        local offset_x = 0
        local offset_y = 0
        local margin = 0
        local y = 10

        local quadX = ((x - 1) * width + margin + (x - 1) * spacing) + offset_x
        local quadY = ((y - 1) * height + margin + (y - 1) * spacing) + offset_y

        print('rect:', quadX, quadY, width, height)

        local o = {name="tile", x=quadX, y=quadY}
        world:add(o, quadX, quadY, 32, 32)
        --o.shape = love.physics.newRectangleShape(width, height)
        --o.fixture = love.physics.newFixture(o.body, o.shape)
        --o.fixture:setUserData("R"..x)  

        --love.physics.newFixture(o.body, o.shape, 1)

        table.insert(colliders, o)
    end

    player = {name="Player", x = 100, y = 50}
    world:add(player, 100, 50,20, 32)
    --player.shape = love.physics.newRectangleShape(20, 32)
    --player.fixture = love.physics.newFixture(player.body, player.shape)
    --player.fixture:setUserData("Player")  

    --love.physics.newFixture(player.body, player.shape, 1)
    --player.body:setFixedRotation(true)
end

function love.update(dt)
    --if string.len(text) > 768 then    -- cleanup when 'text' gets too long
    --    text = "" 
    --end

    --world:update(dt) --, 50, 50)

    --local v_x, v_y = player.body:getLinearVelocity()
	--player.body:setLinearVelocity(0, v_y)

    local x = 0
    local y = 98
    if (love.keyboard.isDown('left')) then
        --player.body:setLinearVelocity(-100, v_y)
        x = -100
    end

    if (love.keyboard.isDown('right')) then
        --player.body:setLinearVelocity(100, v_y)
        x = 100
    end

    local actualX, actualY, cols, len = world:move(player, player.x + (x * dt), player.y + (y * dt))
    player.x = actualX
    player.y = actualY

end

function love.draw()
    local color = {love.graphics.getColor()}
    for _, c in pairs(colliders) do
        love.graphics.setColor(1, 1, 1, 1)

        love.graphics.rectangle("fill", c.x, c.y, 32, 32)

        --local body = c.body
        --local shape = c.shape
        --local pts = {body:getWorldPoints(shape:getPoints())}
        --love.graphics.line(pts)
    end

   love.graphics.setColor(1, 0, 1, 1)

   love.graphics.rectangle("fill", player.x, player.y, 20, 32)
   --local body = player.body
   -- local shape = player.shape
   -- local pts = {body:getWorldPoints(shape:getPoints())}
   -- love.graphics.line(pts)

   love.graphics.setColor(color)

   love.graphics.print(text, 10, 10)
end

function love.resize(w, h)
end

function love.keypressed(k)
end

function love.textinput(t)
end


